/*
 * highlighter.js - v0.1.9
 *
 * Highlighter.js is a tiny (pure javascript) library to allow you to navigate, select and highlight DOM elements.
 * https://github.com/720kb/highlighter.js
 * MIT license
 * 2016-06-13T06:52:13.244Z
 */


Element.prototype.isVisible=function(){"use strict";function t(n,s,o,h,r,l,a){var d=n.parentNode,m=2;return i(n)?9===d.nodeType?!0:"0"===e(n,"opacity")||"none"===e(n,"display")||"hidden"===e(n,"visibility")?!1:(("undefined"==typeof s||"undefined"==typeof o||"undefined"==typeof h||"undefined"==typeof r||"undefined"==typeof l||"undefined"==typeof a)&&(s=n.offsetTop,r=n.offsetLeft,h=s+n.offsetHeight,o=r+n.offsetWidth,l=n.offsetWidth,a=n.offsetHeight),d?"hidden"!==e(d,"overflow")&&"scroll"!==e(d,"overflow")||!(r+m>d.offsetWidth+d.scrollLeft||r+l-m<d.scrollLeft||s+m>d.offsetHeight+d.scrollTop||s+a-m<d.scrollTop)?(n.offsetParent===d&&(r+=d.offsetLeft,s+=d.offsetTop),t(d,s,o,h,r,l,a)):!1:!0):!1}function e(t,e){return window.getComputedStyle?document.defaultView.getComputedStyle(t,null)[e]:t.currentStyle?t.currentStyle[e]:void 0}function i(t){for(;t=t.parentNode;)if(t==document)return!0;return!1}return t(this)},window.smoothScroll=function(){if(void 0!==document.querySelectorAll&&void 0!==window.pageYOffset&&void 0!==history.pushState){var t=function(t){return"HTML"===t.nodeName?-window.pageYOffset:t.getBoundingClientRect().top+window.pageYOffset},e=function(t){return.5>t?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},i=function(t,i,n,s){return n>s?i:t+(i-t)*e(n/s)},n=function(e,n,s){n=n||500;var o=window.pageYOffset;if("number"==typeof e)var h=parseInt(e);else var h=t(e);var r=Date.now(),l=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||function(t){window.setTimeout(t,15)},a=function(){var t=Date.now()-r;window.scroll(0,i(o,h,t,n)),t>n?"function"==typeof s&&s(e):l(a)};a()},s=function(t){t.preventDefault(),location.hash!==this.hash&&window.history.pushState(null,null,this.hash),n(document.getElementById(this.hash.substring(1)),500,function(t){location.replace("#"+t.id)})};return document.addEventListener("DOMContentLoaded",function(){for(var t,e=document.querySelectorAll('a[href^="#"]:not([href="#"])'),i=e.length;t=e[--i];)t.addEventListener("click",s,!1)}),n}}(),function(t){"use strict";var e=function(e){var i=[],n=0;if(this.onSelectedEvent=new t.CustomEvent("Highlighter:selected"),this.onUnderlinedEvent=new t.CustomEvent("Highlighter:underlined"),this.onErasedEvent=new t.CustomEvent("Highlighter:erased"),this.onSkippedEvent=new t.CustomEvent("Highlighter:skipped"),this.onScrolledEvent=new t.CustomEvent("Highlighter:scrolled"),this.onRestartEvent=new t.CustomEvent("Highlighter:restart"),this.position=0,this.dom=t.document.body.getElementsByTagName("*"),this.element=this.dom[this.position],this.scroll=!1,this.scrollDuration=500,this.classAliasList=[],this.identifierClassArray=[],this.color="#08FD31",e&&(e.color&&(this.color=e.color),e.scroll&&(this.scroll=!0),e.scrollDuration&&(this.scrollDuration=Number(e.scrollDuration)),e.viewable)){for(n;n<=this.dom.length;n+=1)this.dom[n]&&this.dom[n].isVisible()&&i.push(this.dom[n]);this.dom=i}};e.prototype.scroller=function(e){this.scroll&&(t.smoothScroll(e,this.scrollDuration),this.onScrolledEvent.eventData={element:e},t.dispatchEvent(this.onScrolledEvent))},e.prototype.underline=function(){this.scroller(this.element,500),this.element&&this.element.style&&(this.element.style.transition="outline 0.55s linear",this.element.style.outline="3px inset "+this.color,this.element.style.outlineOffset="-2px",this.onUnderlinedEvent.eventData={element:this.element},t.dispatchEvent(this.onUnderlinedEvent))},e.prototype.erase=function(){this.element&&this.element.style&&(this.element.style.transition="outline none",this.element.style.outline="none",this.onErasedEvent.eventData={element:this.element},t.dispatchEvent(this.onErasedEvent))},e.prototype.select=function(e){this.position=0,this.element=this.dom[this.position],this.next(e),this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent)},e.prototype.point=function(e){var i=0;if(e&&this.dom&&this.dom.length>0){for(i;i<=this.dom.length;i+=1)if(this.dom[i]===e){this.position=i,this.element=this.dom[i],t.console.log("Highlighter pointing to element:",this.element);break}}else t.console.error("Unable to retrieve starting element")},e.prototype.arrayCompared=function(t,e){return t.filter(function(t){return e.indexOf(t)>-1})},e.prototype.next=function(e){var i=this.position;if(e)if(-1!==e.indexOf("#"))for(i;i<=this.dom.length;i+=1){if(this.dom[i]&&this.dom[i].id&&this.dom[i].id.toString()===e.replace("#","")){this.element=this.dom[i],this.position=i+1,this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent);break}if(i>=this.dom.length){this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No next elements, restarting from the first element in page");break}}else if(-1!==e.indexOf("."))for(this.identifierClassArray=e.toString().replace(".","").split(" "),i;i<=this.dom.length;i+=1){if(this.dom[i]&&this.dom[i].classList&&-1!==e.indexOf(".")&&(this.classAliasList=this.dom[i].classList.toString().split(" "),this.arrayCompared(this.classAliasList,this.identifierClassArray).length>0)){this.element=this.dom[i],this.position=i+1,this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent);break}if(i>=this.dom.length){this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No next elements, restarting from the first element in page");break}}else if(e.indexOf("<")>-1)for(i;i<=this.dom.length;i+=1){if(this.dom[i]&&this.dom[i].tagName&&this.dom[i].tagName.toString().toLowerCase()===e.replace("<","").replace(">","")){this.element=this.dom[i],this.position=i+1,this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent);break}if(i>=this.dom.length){this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No next elements, restarting from the first element in page");break}}else t.console.error("Please set a correct #id or .class or <tag> identifier");else this.position+=1,this.position>this.dom.length&&(this.position=0,this.element=this.dom[this.position],t.dispatchEvent(this.onRestartEvent),t.console.info("No next elements, restarting from the first element in page")),this.element=this.dom[this.position],this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent)},e.prototype.previous=function(e){var i=this.position;if(e)if(-1!==e.indexOf("#"))for(i<=this.position;i>=0;i-=1){if(this.dom[i]&&this.dom[i].id&&this.dom[i].id.toString()===e.replace("#","")){this.element=this.dom[i],this.position=i-1,this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent);break}if(i<this.dom.length){this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No previous elements, restarting from the first element in page");break}}else if(e.indexOf(".")>-1)for(this.identifierClassArray=e.toString().replace(".","").split(" "),i<=this.position;i>=0;i-=1){if(this.dom[i]&&this.dom[i].classList&&-1!==e.indexOf(".")&&(this.classAliasList=this.dom[i].classList.toString().split(" "),this.arrayCompared(this.classAliasList,this.identifierClassArray).length>0)){this.element=this.dom[i],this.position=i-1,this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent);break}if(i<this.dom.length){this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No previous elements, restarting from the first element in page");break}}else if(e.indexOf("<")>-1)for(i<=this.position;i>=0;i-=1){if(this.dom[i]&&this.dom[i].tagName&&this.dom[i].tagName.toString().toLowerCase()===e.replace("<","").replace(">","")){this.element=this.dom[i],this.position=i-1,this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent);break}if(i<this.dom.length){this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No previous elements, restarting from the first element in page");break}}else t.console.error("You must set a correct #id or .class or <tag> parameter");else this.position-=1,this.position<0&&(this.position=0,t.dispatchEvent(this.onRestartEvent),t.console.info("No previous elements, restarting from the first element in page")),this.element=this.dom[this.position],this.onSelectedEvent.eventData={element:this.element},t.dispatchEvent(this.onSelectedEvent)},e.prototype.skipNext=function(e){Number(e)>0&&(this.position+=e,this.onSkippedEvent.eventData={element:this.dom[this.position]},t.dispatchEvent(this.onSkippedEvent)),Number(e)>this.dom.length&&(this.position=0,this.element=this.dom[this.position],t.dispatchEvent(this.onRestartEvent),t.console.log("No next elements, restarting from the first DOM element"))},e.prototype.skipPrev=function(e){Number(e)>0&&(this.position-=e,this.onSkippedEvent.eventData={element:this.dom[this.position]},t.dispatchEvent(this.onSkippedEvent)),this.position<0&&(this.position=0,this.element=this.dom[this.position],t.dispatchEvent(this.onRestartEvent),t.console.log("No previous elements, restarting from the first DOM element"))},t.Highlighter=e}(window);
//# sourceMappingURL=highlighter.min.js.map